local E, L, V, P, G, _ = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore
local DT = E:GetModule('DataTexts');

local menuFrame = CreateFrame("Frame", "MaUIBerufe", E.UIParent)
	  menuFrame:SetTemplate("Transparent", true)

local menuList = {}
local cgreen = '|cff31B404'
local cyellow = '|cffFFBF00'

local function getProf(index)
	local name, icon, skillLevel, maxSkillLevel, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)

	if (skillLevel == maxSkillLevel) then
		return format (name .. " (" .. cgreen .. '' .. skillLevel .. "|r)")
	else
		return format (name .. " (" .. cyellow .. '' .. skillLevel .. "|r/" .. cgreen .. '' .. maxSkillLevel .. "|r)")
	end
 end
 
local function castProf(index)
	local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine,
		skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(index)
		
	if name == GetSpellInfo(2575) then
		name = GetSpellInfo(2656)
	end
	
	CastSpellByName(name, self)
end

local function setupProf()
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions()
	local mI = 1
	
	menuList = {}
	
	if (prof1 == nil) and (prof2 == nil) then
			tinsert(menuList, mI, {text = "|cffFFBF00Keine Hauptberufe", func = function() end})
			mI = mI + 1
	else
		tinsert(menuList, mI, {text = "|cffFFBF00Hauptberufe", isTitle = true, func = function() end})
		mI = mI + 1
		
		if prof1 ~= nil then
			tinsert(menuList, mI, {text = getProf(prof1), func = function() castProf(prof1) end})
			mI = mI + 1
		end
	
		if prof2 ~= nil then
			tinsert(menuList, mI, {text = getProf(prof2), func = function() castProf(prof2) end})
			mI = mI + 1
		end
	end
	
	tinsert(menuList, mI, {text = "", func = function() end})
		mI = mI + 1
	
	if  (archaeology == nil) and (cooking == nil) and (firstAid == nil) and (fishing == nil)  then
		tinsert(menuList, mI, {text = "|cffFFBF00Keine Nebenberufe", func = function() end})
		mI = mI + 1
	else
		tinsert(menuList, mI, {text = "|cffFFBF00Nebenberufe", func = function() end})
		mI = mI + 1
		
		if archaeology ~= nil then
			tinsert(menuList, mI, {text = getProf(archaeology), func = function() castProf(archaeology) end})
			mI = mI + 1
		end
		
		if cooking ~= nil then
			tinsert(menuList, mI, {text = getProf(cooking), func = function() castProf(cooking) end})
			mI = mI + 1
		end
		
		if firstAid ~= nil then
			tinsert(menuList, mI, {text = getProf(firstAid), func = function() castProf(firstAid) end})
			mI = mI + 1
		end
		
		if fishing ~= nil then
			tinsert(menuList, mI, {text = getProf(fishing), func = function() end})
			mI = mI + 1
		end
	end
end

local function OnEnter(self, ...)
	self.text:SetText("Berufe")
end

local function OnClick(self)
	setupProf()
	E:DropDown(menuList, menuFrame)
end

DT:RegisterDatatext('Berufe', nil, OnEnter, nil, OnClick)